>extern "pic",pic,$a020
>extern "font",font,$564
>extern "ydatas",ydatas,$400
>extern "music",init,$36cc

pic     = $40000
font    = pic+$a020
ydatas  = font+$564
init    = ydatas+$400

y = 30

code:	jmp	start

org init+$36cc
load init+$36cc

start:	lea	$dff000,a6
	move.w	#$7fff,$9a(a6)
	move.w	#$8400,$96(a6)
	clr.l	$0.w

	lea	colortab(pc),a0
	lea	here(pc),a1
	move.l	#$4bdffffe,d0
	move.w	#$30,d1
hloop:	move.l	d0,(a1)+
	move.w	#$01a0,(a1)+
	move.w	(a0)+,(a1)+
	add.l	#$04000000,d0
	dbf	d1,hloop

	lea	text(pc),a0
	lea	ttab-1(pc),a1
	lea	text(pc),a2
getnext:move.b	(a0)+,d0
	beq.s	endreached
	cmp.b	#"W",d0
	bne.s	doit
	move.b	(a0)+,d0
	add.b	#$50,d0
	move.b	d0,(a2)+
	bra.s	getnext
doit:	clr.w	d1
search:	addq.b	#$1,d1
	cmp.b	#$2e,d1
	beq.s	found
	cmp.b	(a1,d1.w),d0
	bne.s	search
found:	add.b	d1,d1
	move.b	d1,(a2)+
	bra.s	getnext

endreached:
	clr.b	(a2)

	lea	ytab,a0
	move.w	#$ff,d0
	clr.w	d1
yloop:	move.w	d1,(a0)+
	add.w	#$28,d1
	dbf	d0,yloop

	lea	sscr,a0
	move.w	#$197,d0
cllop:	clr.l	(a0)+
	dbf	d0,cllop

	lea	pic+$a000,a0
	lea	cols(pc),a1
	moveq	#$f,d0
	move.w	#$0180,d1
	move.l	#$01200000,d2
cloop:	move.l	d2,$40(a1)
	move.w	d1,(a1)+
	move.w	(a0)+,(a1)+
	addq.w	#$2,d1
	add.l	#$00020000,d2
	dbf	d0,cloop

	lea	ydatas,a2
	lea	ytab,a3

	moveq	#$1,d0
	jsr	init

	move.l	#copper,$80(a6)

rast:	cmp.b	#$ff,$6(a6)
	bne.s	rast

	bsr	clearscr
	bsr	bend

	btst	#$6,$bfe001
	bne.s	rast

	moveq	#$0,d0
	jsr	init

	btst	#$e,$2(a6)
	bne.s	*-8

	move.w	#$e02c,$9a(a6)
	move.w	#$0400,$96(a6)

	move.l	4.w,a6
	lea	gfxname(pc),a1
	jsr	-408(a6)
	move.l	d0,a1
	move.l	38(a1),$dff080
	jmp	-414(a6)

gfxname:dc.b	'graphics.library',0,0

screens:dc.l	sinscr,sinscr2

clearscr:
	btst	#$e,$2(a6)
	bne.s	clearscr
	lea	screens(pc),a0
	move.l	(a0)+,d6
	move.l	(a0),d7
	move.l	d6,(a0)
	move.l	d7,-(a0)
	move.l	#$01000000,$40(a6)
	move.l	d6,$54(a6)
	clr.w	$66(a6)
	move.w	#64*256+20,$58(a6)

	add.l	#y*40,d7
	lea	poi+2(pc),a0
	move.w	d7,4(a0)
	swap	d7
	move.w	d7,(a0)

	jsr	init+4

	tst.w	waiter2
	beq.s	scroll
	subq.w	#$1,waiter2
	rts

scroll:	btst	#$e,$2(a6)
	bne.s	scroll

	move.w	#$e9f0,$40(a6)
	move.l	#$ffffffff,$44(a6)
	clr.l	$64(a6)
	move.l	#sscr+2,$50(a6)
	move.l	#sscr,$54(a6)
	move.w	#64*15+22,$58(a6)

	lea	waiter(pc),a0
	subq.w	#$2,(a0)
	bmi.s	getchar
	rts

waiter:	dc.w	$0
waiter2:dc.w	$0

getchar:clr.w	d0
	lea	tpoi(pc),a1
	move.l	(a1),a4
	move.b	(a4)+,d0
	beq.s	nowait
	bpl.s	allok
	sub.b	#$80,d0
	ext.w	d0
	lsl.w	#$5,d0
	move.w	d0,waiter2
	bra.s	allok2
nowait:	lea	text(pc),a4
allok2:	move.b	(a4)+,d0
allok:	move.l	a4,(a1)
	lea	xsize-2(pc),a1
	move.w	(a1,d0.w),(a0)

	lea	font-2,a0
	add.w	d0,a0
	lea	sscr+42,a1

	btst	#$e,$2(a6)
	bne.s	*-8
	move.w	#$09f0,$40(a6)
	move.l	#$005a002a,$64(a6)
	move.l	a0,$50(a6)
	move.l	a1,$54(a6)
	move.w	#64*15+1,$58(a6)
	rts

bend:	btst	#$e,$2(a6)
	bne.s	*-8

	move.w	#$0dfc,$40(a6)
	move.w	#$0026,$62(a6)
	move.l	#$002a0026,$64(a6)

	lea	sscr+2,a0
	move.l	d6,a1
	move.w	offset(pc),d6
	add.w	addoff(pc),d6
	move.w	d6,offset
	move.w	addspd(pc),d5
	moveq	#$1,d7
	moveq	#$13,d0
	move.w	#$3ff,d4
xloop:	moveq	#$f,d1
xloop2:	add.w	d5,d6
	and.w	d4,d6
	ror.w	#$1,d7
	clr.w	d2
	move.b	(a2,d6.w),d2
	add.w	d2,d2
	move.w	(a3,d2.w),d2
	add.w	d2,a1
	move.w	d7,$44(a6)
	move.l	a0,$50(a6)
	move.l	a1,$4c(a6)
	move.l	a1,$54(a6)
	move.w	#64*15+1,$58(a6)
	sub.w	d2,a1
	dbf	d1,xloop2
	addq.w	#$2,a0
	addq.w	#$2,a1
	dbf	d0,xloop
	rts

addoff:	dc.w	-2
addspd:	dc.w	1
offset:	dc.w	0

copper:	dc.w	$0100,$5200
	dc.w	$008e,y+$2c*256+$81
	dc.w	$0090,$0dc1
	dc.w	$0092,$0038
	dc.w	$0094,$00d0
	dc.w	$0108,$0000
	dc.w	$010a,$0000
	dc.w	$00e0,pic+[y*40]/$10000
	dc.w	$00e2,pic+[y*40]
	dc.w	$00e4,pic+$2800+[y*40]/$10000
	dc.w	$00e6,pic+$2800+[y*40]
	dc.w	$00e8,pic+$5000+[y*40]/$10000
	dc.w	$00ea,pic+$5000+[y*40]
	dc.w	$00ec,pic+$7800+[y*40]/$10000
	dc.w	$00ee,pic+$7800+[y*40]
poi:	dc.w	$00f0,sinscr/$10000
	dc.w	$00f2,sinscr
	dc.w	$01a0,$0f00
cols:	blk.l	16,0
sprites:blk.l	8*2,0
	dc.w	$0104,$0028
	dc.w	$2b0f,$fffe
	dc.w	$0180,$0889
	dc.w	$2c0f,$fffe
	dc.w	$0180,$0000
here:	blk.l	49*2,0
	dc.w	$2c0f,$fffe
	dc.w	$0180,$0889
	dc.w	$2d0f,$fffe
	dc.w	$0180,$0000
	dc.w	$ffff,$fffe

colortab:
	dc.w	$f00,$f10,$f20,$f30,$f40,$f50,$f60,$f70
	dc.w	$f80,$f90,$fa0,$fb0,$fc0,$fd0,$fe0,$ff0
	dc.w	$ef0,$df0,$cf0,$bf0,$af0,$9f0,$8f0,$7f0
	dc.w	$6f0,$5f0,$4f0,$3f0,$2f0,$1f0,$0f0,$0f2
	dc.w	$0f4,$0f6,$0f8,$0fa,$0fc,$0fe,$0ef,$0df
	dc.w	$0cf,$0bf,$0af,$09f,$07f,$05f,$03f,$01f
	dc.w	$00f

ttab:	dc.b	"abcdefghijklmnopqrstuvwxyz"
	dc.b	"0123456789,.!?() -:'"

xsize:	dc.w	14,14,14,14,12,12,14,14,5,7,14,12,15
	dc.w	14,14,14,14,14,14,13,14,15,15,15,14,14
	dc.w	14,8,14,14,15,14,14,14,14,14
	dc.w	5,5,5,13,5,5,10,14,14,14

tpoi:	dc.l	text
text:	dc.b	"vision factory   W4     presents : strider (kotz)"
	dc.b	"   W5      ",0

even
ytab:
sinscr  = ytab+$200
sinscr2 = sinscr+$2800
sscr    = sinscr2+$2800
